
#define NumElements(a) ((int)((sizeof a)/(sizeof a[0])))

#define Trace() fprintf(stderr,"%s:%d\n",__FILE__,__LINE__)  
  
#define ErrAbort(expression) \
    do { \
      int status = expression; \
      if (status) \
        { \
          fprintf(stderr,"Error %d: %s at %s:%d: " #expression "\n", \
                    status, strerror(status), \
                    __FILE__,__LINE__); \
          abort(); \
        } \
    } while (0)

  
#define ErrnoAbort(expression) \
    do { \
      int status = expression; \
      if (status) \
        { \
          fprintf(stderr,"Error %d: %s at %s:%d: " #expression "\n", \
                    errno, strerror(errno), \
                    __FILE__,__LINE__); \
          abort(); \
        } \
    } while (0)


